/*
 * PersonDialog.java   E.L. 2004-02-21
 *
 * Klassen ligger i pakken mittBibliotek.
 * Dette er en dialog tilpasset klassen mittBibliotek.Person.
 * Feltet med personnummer er lst for redigering.
 * Et Person-objekt er argument til visDialog(). Dersom dette inneholder et
 * negativt personnummer, vil teksten "ikke definert" vises i nummerfeltet i dialogen.
 */

package mittBibliotek;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;
import static javax.swing.JOptionPane.*;

public class PersonDialog extends MinDialog {  // MinDialog i pakken mittBibliotek
  private JTextField persnrFelt = new JTextField(8);
  private JTextField fornavnFelt = new JTextField(15);
  private JTextField etternavnFelt = new JTextField(15);

  public PersonDialog(JFrame forelder) {
    super(forelder, "Person");
    add(new JPanel(), BorderLayout.NORTH);  // litt "luft"
    add(new PersonDatapanel(), BorderLayout.CENTER);
    add(finnKnappepanel(), BorderLayout.SOUTH);
    pack();
  }

  private class PersonDatapanel extends JPanel {
    public PersonDatapanel() {
      setLayout(new GridLayout(3, 2));
      add(new JLabel("Personnr: ", JLabel.RIGHT));
      add(persnrFelt);
      persnrFelt.setEditable(false); // kan ikke endre nummeret
      add(new JLabel("Fornavn: ", JLabel.RIGHT));
      add(fornavnFelt);
      add(new JLabel("Etternavn: ", JLabel.RIGHT));
      add(etternavnFelt);
    }
  }

  /* Negativt nummer signaliserer at nummeret ikke er definert. */
  public boolean visDialog(Person personen) {
    if (personen.finnPersonNr() < 0) persnrFelt.setText("ikke definert");
    else persnrFelt.setText("" + personen.finnPersonNr());
    fornavnFelt.setText(personen.finnFornavn());
    etternavnFelt.setText(personen.finnEtternavn());
    settOk(false);
    pack();
    fornavnFelt.requestFocus();
    setVisible(true);
    if (erOk()) {
      personen.settFornavn(fornavnFelt.getText());
      personen.settEtternavn(etternavnFelt.getText());
      return true;
    }
    return false;
  }

  /*
   * Bde fornavn og etternavn m vre fylt ut av brukeren.
   */
  protected boolean okData() {
    String fornavn = fornavnFelt.getText().trim();
    String etternavn = etternavnFelt.getText().trim();
    if (fornavn.equals("") || etternavn.equals("")) {
      showMessageDialog(PersonDialog.this, "Bde for- og etternavn m fylles ut!");
      if (!fornavn.equals("")) etternavnFelt.requestFocus();
      else fornavnFelt.requestFocus();
      return false;
    }
    return true;
  }
}