/*
 * DatabasePoolTest.java   E.L. 2004-03-02
 *
 * Enkel utprving av klassene DatabasePool og Forbindelse.
 */

package mittBibliotek.database;
import static javax.swing.JOptionPane.*;

class DatabasePoolTest {
  public static void main(String[] args) throws Exception {
    String dbDriver = "oracle.jdbc.driver.OracleDriver";
    String dbNavn = "jdbc:oracle:thin:@baron.stud.idb.hist.no:1521:orcl";
    String brukernavn = showInputDialog("Brukernavn: ");
    String passord = showInputDialog("Passord: ");
    int poolKapasitet = 3;

    DatabasePool dbPool =
          new DatabasePool(poolKapasitet, dbDriver, dbNavn, brukernavn, passord);

    System.out.println("*** Skal reservere forbindelser, en mer enn det er i poolen.");
    for (int i = 0; i < poolKapasitet + 1; i++) {
      Forbindelse dbForb = dbPool.reserverForbindelse();
      System.out.println("*** Har ftt tildelt forbindelse nr " + dbForb.finnNr() + ".");
    }
    System.out.println("\n*** Frigir alle forbindelsene,  den siste skal ogs bli lukket");
    for (int i = 0; i < poolKapasitet + 1; i++) {
      dbPool.frigiForbindelse(i);
    }
    System.out.println("\n*** Lukker alle forbindelsene.");
    dbPool.lukkAlleForbindelser();
  }
}

/* Utskrift:
*** Skal reservere forbindelser, en mer enn det er i poolen.
Reserverer forbindelse 0
*** Har ftt tildelt forbindelse nr 0.
Reserverer forbindelse 1
*** Har ftt tildelt forbindelse nr 1.
Reserverer forbindelse 2
*** Har ftt tildelt forbindelse nr 2.
Reserverer forbindelse 3
*** Har ftt tildelt forbindelse nr 3.

*** Frigir alle forbindelsene,  den siste skal ogs bli lukket
Frigir forbindelse 0.
Frigir forbindelse 1.
Frigir forbindelse 2.
Frigir forbindelse 3.
Lukker forbindelse nr. 3.

*** Lukker alle forbindelsene.
Lukker forbindelse nr. 0.
Lukker forbindelse nr. 1.
Lukker forbindelse nr. 2.
*/
