/*
 * DbWrapperFabrikkImpl.java   E.L. 2004-03-02
 *
 * Implementerer en fabrikk for tilknytninger til en bestemt database.
 */

package mittBibliotek.database;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class DbWrapperFabrikkImpl extends UnicastRemoteObject implements DbWrapperFabrikk {
  private DatabasePool dbPool;
  private int feilkode; // brukes i registrerNyPerson() i klassen DatabaseImpl

  public DbWrapperFabrikkImpl(int poolKapasitet, String dbDriver, String dbNavn, String brukernavn, String passord,
         int startFeilkode) throws Exception {
    dbPool = new DatabasePool(poolKapasitet, dbDriver, dbNavn, brukernavn, passord);
    feilkode = startFeilkode;
  }

  public Database lagDbWrapper() throws RemoteException {
    return new DatabaseImpl(dbPool, feilkode);
  }

  public void stengDatabasePool() {
    dbPool.lukkAlleForbindelser();
  }
}
