/*
 * Forbindelse.java   E.L. 2004-03-02
 *
 * Et objekt av denne klassen inneholder ndvendige data for en databaseforbindelse.
 * Konstruktren og noen av metodene har pakketilgang,
 * det er meningen at de kun skal kalles fra klassen DatabasePool.
 *
 * Feilhndtering: Konstruktren og lukkForbindelse() kan kaste SQLException,
 * ellers er det ikke aktuelt  kaste unntak.
 */

package mittBibliotek.database1_4;
import java.sql.*;
public class Forbindelse {
  private int nr;  // identifiserer en forbindelse
  private Connection dbForb;
  private boolean ledig;

  /* Pakketilgang */
  Forbindelse(int startNr, String dbNavn, String brukernavn, String passord)
                     throws SQLException {
    nr = startNr;
    dbForb = DriverManager.getConnection(dbNavn, brukernavn, passord);
    ledig = true;
  }

  void lukkForbindelse() throws SQLException {
    if (dbForb != null) dbForb.close();
  }

  void settLedig(boolean nyLedig) {
    ledig = nyLedig;
  }

  /* Offentlig tilgang */
  public int finnNr() {
    return nr;
  }

  public Connection finnForbindelse() {
    return dbForb;
  }

  public boolean erLedig() {
    return ledig;
  }

  public String toString() {
    String resultat = "Forbindelse nr " + nr;
    if (ledig) resultat +=  " er ledig. ";
    else resultat += " er ikke ledig. ";
    return resultat;
  }
}
